<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 m3 Media Services Limited                         |
| For contact details, see: http://www.m3.net/                              |
|                                                                           |
| Copyright (c) 2000-2003 the phpAdsNew developers                          |
| For contact details, see: http://www.phpadsnew.com/                       |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: banner-acl.php 3638 2005-09-06 15:44:27Z chris $
*/

// Set options
// Require the initialisation file
require_once '../../init.php';
require_once MAX_PATH . '/www/admin/config.php';

require_once MAX_PATH . '/www/admin/lib-statistics.inc.php';


// Register input variables
phpAds_registerGlobal('time', 'cap', 'session_capping', 'clientid', 'campaignid', 'bannerid');

// Security check
phpAds_checkAccess(phpAds_Admin + phpAds_Agency);

// security check
if (phpAds_isUser(phpAds_Agency))
{
	$query = "SELECT ".
		$conf['table']['prefix'].$conf['table']['banners'].".bannerid as bannerid".
		" FROM ".$conf['table']['prefix'].$conf['table']['clients'].
		",".$conf['table']['prefix'].$conf['table']['campaigns'].
		",".$conf['table']['prefix'].$conf['table']['banners'].
		" WHERE ".$conf['table']['prefix'].$conf['table']['campaigns'].".clientid=".$clientid.
		" AND ".$conf['table']['prefix'].$conf['table']['banners'].".campaignid=".$campaignid.
		" AND ".$conf['table']['prefix'].$conf['table']['banners'].".bannerid=".$bannerid.
		" AND ".$conf['table']['prefix'].$conf['table']['banners'].".campaignid=".$conf['table']['prefix'].$conf['table']['campaigns'].".campaignid".
		" AND ".$conf['table']['prefix'].$conf['table']['campaigns'].".clientid=".$conf['table']['prefix'].$conf['table']['clients'].".clientid".
		" AND ".$conf['table']['prefix'].$conf['table']['clients'].".agencyid=".phpAds_getUserID();
	$res = phpAds_dbQuery($query)
		or phpAds_sqlDie();
	if (phpAds_dbNumRows($res) == 0) {
		phpAds_PageHeader("2");
		phpAds_Die ($strAccessDenied, $strNotAdmin);
	}
} else {
	// if admin get agencyid for agency which is connected with this banner
	$query = "SELECT ".
		$conf['table']['prefix'].$conf['table']['clients'].".agencyid as agencyid".
		" FROM ".$conf['table']['prefix'].$conf['table']['clients'].
		",".$conf['table']['prefix'].$conf['table']['campaigns'].
		",".$conf['table']['prefix'].$conf['table']['banners'].
		" WHERE ".$conf['table']['prefix'].$conf['table']['campaigns'].".clientid=".$clientid.
		" AND ".$conf['table']['prefix'].$conf['table']['banners'].".campaignid=".$campaignid.
		" AND ".$conf['table']['prefix'].$conf['table']['banners'].".bannerid=".$bannerid.
		" AND ".$conf['table']['prefix'].$conf['table']['banners'].".campaignid=".$conf['table']['prefix'].$conf['table']['campaigns'].".campaignid".
		" AND ".$conf['table']['prefix'].$conf['table']['campaigns'].".clientid=".$conf['table']['prefix'].$conf['table']['clients'].".clientid";
	$res = phpAds_dbQuery($query)
		or phpAds_sqlDie();
	if ($row = phpAds_dbFetchArray ($res)) {
		$agencyid = $row['agencyid'];
	}
}

// Set initialize constant
define('MAX_ACL_INITIALIZED', 1);

$sqlDeleteExistingLimitations = "
		DELETE FROM 
			".$conf['table']['prefix'].$conf['table']['acls']." 
		WHERE 
			bannerid='".$bannerid."'";

$sqlInsertLimitation = "
		INSERT INTO
			".$conf['table']['prefix'].$conf['table']['acls']."
		SET
			bannerid  	   = '".$bannerid."',
			logical   	   = '%s',
			type  	  	   = '%s',
			data  	  	   = '%s',
			comparison     = '%s',
			executionorder = '%d'";

$sqlSelectLimitations = "
		SELECT
			*
		FROM
			".$conf['table']['prefix'].$conf['table']['acls']."
		WHERE
			bannerid = '".$bannerid."'
		ORDER BY
			executionorder";

$compileFunction = 'phpAds_compileBannerLimitation';
$compileArgument = $bannerid;

$aclFormHiddenInputs = "<input type='hidden' name='clientid' value='".$clientid."'>";
$aclFormHiddenInputs .= "<input type='hidden' name='campaignid' value='".$campaignid."'>";
$aclFormHiddenInputs .= "<input type='hidden' name='bannerid' value='".$bannerid."'>";

function Max_aclPostForm() {
	global $strDeliveryCapping, $strTimeCapping, $time, $strImpressionCapping, $strImpressionCappingSession,
			$session_capping, $tabindex, $strHours, $strMinutes, $strSeconds, $cap, $strTimes;

	$ret = "<table border='0' width='100%' cellpadding='0' cellspacing='0' bgcolor='#FFFFFF'>";
	$ret .= "<tr><td height='25' colspan='3' bgcolor='#FFFFFF'><b>".$strDeliveryCapping."</b></td></tr>";
	$ret .= "<tr><td height='1' colspan='3' bgcolor='#888888'><img src='images/break.gif' height='1' width='100%'></td></tr>";
	$ret .= "<tr><td height='10' colspan='3'>&nbsp;</td></tr>";
	
	$ret .= "<tr><td width='30'>&nbsp;</td>";
	$ret .= "<td width='200'>".$strTimeCapping."</td>";
	$ret .= "<td valign='top'>";
	$ret .= "<input id='timehour' class='flat' type='text' size='3' name='time[hour]' value='".$time['hour']."' onKeyUp=\"phpAds_formLimitUpdate(this);\" tabindex='".($tabindex++)."'> ".$strHours." &nbsp;&nbsp;";
	$ret .= "<input id='timeminute' class='flat' type='text' size='3' name='time[minute]' value='".$time['minute']."' onKeyUp=\"phpAds_formLimitUpdate(this);\" tabindex='".($tabindex++)."'> ".$strMinutes." &nbsp;&nbsp;";
	$ret .= "<input id='timesecond' class='flat' type='text' size='3' name='time[second]' value='".$time['second']."' onBlur=\"phpAds_formLimitBlur(this);\" onKeyUp=\"phpAds_formLimitUpdate(this);\" tabindex='".($tabindex++)."'> ".$strSeconds." &nbsp;&nbsp;";
	$ret .= "</td></tr>";
	$ret .= "<tr><td><img src='images/spacer.gif' height='1' width='100%'></td>";
	$ret .= "<td colspan='2'><img src='images/break-l.gif' height='1' width='200' vspace='6'></td></tr>";
	
	$ret .= "<tr><td width='30'>&nbsp;</td>";
	$ret .= "<td width='200'>".$strImpressionCapping."</td>";
	$ret .= "<td valign='top'>";
	$ret .= "<input class='flat' type='text' size='3' name='cap' value='".$cap."' onBlur=\"phpAds_formCapBlur(this);\" tabindex='".($tabindex++)."'> ".$strTimes;
	$ret .= "</td></tr>";
	
	$ret .= "<tr><td><img src='images/spacer.gif' height='1' width='100%'></td>";
	$ret .= "<td colspan='2'><img src='images/break-l.gif' height='1' width='200' vspace='6'></td></tr>";
	
	$ret .= "<tr><td width='30'>&nbsp;</td>";
	$ret .= "<td width='200'>".$strImpressionCappingSession."</td>";
	$ret .= "<td valign='top'>";
	$ret .= "<input class='flat' type='text' size='3' name='session_capping' value='".$session_capping."' onBlur=\"phpAds_formCapBlur(this);\" tabindex='".($tabindex++)."'> ".$strTimes;
	$ret .= "</td></tr>";
	
	$ret .= "<tr><td height='10' colspan='3'>&nbsp;</td></tr>";
	$ret .= "<tr><td height='1' colspan='3' bgcolor='#888888'><img src='images/break.gif' height='1' width='100%'></td></tr>";
	
	$ret .= "</table>";
	
	return $ret;
}

function Max_aclFormRequirements()
{
	$ret = "<script language='JavaScript'>
<!--
	
	function phpAds_formCapBlur (i)
	{
		if (i.value == '' || i.value == '0') i.value = '-'
	}
	
	function phpAds_formLimitBlur (i)
	{
		f = i.form;
		
		if (f.timehour.value == '') f.timehour.value = '0';
		if (f.timeminute.value == '') f.timeminute.value = '0';
		if (f.timesecond.value == '') f.timesecond.value = '0';
		
		phpAds_formLimitUpdate (i);
	}
			
	function phpAds_formLimitUpdate (i)
	{
		f = i.form;
		
		// Set -
		if (f.timeminute.value == '-' && f.timehour.value != '-') f.timeminute.value = '0';
		if (f.timesecond.value == '-' && f.timeminute.value != '-') f.timesecond.value = '0';
		
		// Set 0
		if (f.timehour.value == '0') f.timehour.value = '-';
		if (f.timehour.value == '-' && f.timeminute.value == '0') f.timeminute.value = '-';
		if (f.timeminute.value == '-' && f.timesecond.value == '0') f.timesecond.value = '-';
	}
	
//-->
</script>";
	return $ret;
}

function Max_AclSelectAdditionalInfo()
{
	global $time, $cap, $session_capping, $conf, $bannerid;
	
	if (!isset($time) || !isset($cap) || !isset($session_capping))
	{
		$res = phpAds_dbQuery("
			SELECT
				block,
				capping,
				session_capping
			FROM
				".$conf['table']['prefix'].$conf['table']['banners']."
			WHERE
				bannerid = '".$bannerid."'
		");
		
		if ($row = phpAds_dbFetchArray ($res))
		{
			if (!isset($time))
			{
				$seconds = $row['block'];
				
				$time['hour'] = ($seconds - ($seconds % 3600)) / 3600;
				$seconds = $seconds % 3600;
				
				$time['minute'] = ($seconds - ($seconds % 60)) / 60;
				$seconds = $seconds % 60;
				
				$time['second'] = $seconds;
			}
			
			if (!isset($cap))
				$cap = $row['capping'];
	
			if (!isset($session_capping))
				$session_capping = $row['session_capping'];
	
		}
	}
	
	if ($time['hour'] == 0 && $time['minute'] == 0 && $time['second'] == 0) $time['second'] = '-'; 
	if ($time['hour'] == 0 && $time['minute'] == 0) $time['minute'] = '-'; 
	if ($time['hour'] == 0) $time['hour'] = '-';
	if ($cap == 0) $cap = '-';
	if ($session_capping == 0) $session_capping = '-';
}

function Max_AclSaveAdditionalInfo()
{
	global $time, $cap, $session_capping, $conf, $bannerid;
	
	// Set time limit
	if (isset($time)) {
		$block = 0;
		if ($time['second'] != '-') $block += (int)$time['second'];
		if ($time['minute'] != '-') $block += (int)$time['minute'] * 60;
		if ($time['hour'] != '-') 	$block += (int)$time['hour'] * 3600;
	} else {
		$block = 0;
	}
	// Set capping and session capping
	if (isset($cap) && $cap != '-') {
		$cap = (int)$cap;
	} else {
		$cap = 0;
	}
	if (isset($session_capping) && $session_capping != '-') {
		$session_capping = (int)$session_capping;
	} else {
		$session_capping = 0;
	}
	$res = phpAds_dbQuery("
		UPDATE
			".$conf['table']['prefix'].$conf['table']['banners']."
		SET
			block='".$block."', capping='".$cap."', session_capping='".$session_capping."'
		WHERE
			bannerid='".$bannerid."'
	") or phpAds_sqlDie();
}

$aclMoveAfterUpdateUrl = 'banner-append.php?clientid='.$clientid.'&campaignid='.$campaignid.'&bannerid='.$bannerid;
$sessionPrefsForUrl = $session['prefs']['campaign-banners.php'];

// Turn off comppression to prevent call another ob_start inside this one
$GLOBALS['_MAX']['PREF']['content_gzip_compression'] = false;

ob_start();
	// Get other banners
	$res = phpAds_dbQuery("
		SELECT
			*
		FROM
			".$conf['table']['prefix'].$conf['table']['banners']."
		WHERE
			campaignid = '$campaignid'
		".phpAds_getBannerListOrder($navorder, $navdirection)."
	");
	
	while ($row = phpAds_dbFetchArray($res)) {
		phpAds_PageContext (
			phpAds_buildBannerName ($row['bannerid'], $row['description'], $row['alt']),
			"banner-acl.php?clientid=".$clientid."&campaignid=".$campaignid."&bannerid=".$row['bannerid'],
			$bannerid == $row['bannerid']
		);
	}
	
	phpAds_PageShortcut($strClientProperties, 'advertiser-edit.php?clientid='.$clientid, 'images/icon-advertiser.gif');
	phpAds_PageShortcut($strCampaignProperties, 'campaign-edit.php?clientid='.$clientid.'&campaignid='.$campaignid, 'images/icon-campaign.gif');
	phpAds_PageShortcut($strBannerHistory, 'stats-banner-history.php?clientid='.$clientid.'&campaignid='.$campaignid.'&bannerid='.$bannerid, 'images/icon-statistics.gif');
	
	$extra  = "<form action='banner-modify.php'>";
	$extra .= "<input type='hidden' name='clientid' value='$clientid'>";
	$extra .= "<input type='hidden' name='campaignid' value='$campaignid'>";
	$extra .= "<input type='hidden' name='bannerid' value='$bannerid'>";
	$extra .= "<input type='hidden' name='returnurl' value='banner-acl.php'>";
	$extra .= "<br /><br />";
	$extra .= "<b>$strModifyBanner</b><br />";
	$extra .= "<img src='images/break.gif' height='1' width='160' vspace='4'><br />";
	$extra .= "<img src='images/icon-duplicate-banner.gif' align='absmiddle'>&nbsp;<a href='banner-modify.php?clientid=".$clientid."&campaignid=".$campaignid."&bannerid=".$bannerid."&duplicate=true&returnurl=banner-acl.php'>$strDuplicate</a><br />";
	$extra .= "<img src='images/break.gif' height='1' width='160' vspace='4'><br />";
	$extra .= "<img src='images/icon-move-banner.gif' align='absmiddle'>&nbsp;$strMoveTo<br />";
	$extra .= "<img src='images/spacer.gif' height='1' width='160' vspace='2'><br />";
	$extra .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
	$extra .= "<select name='moveto' style='width: 110;'>";
	
	if (phpAds_isUser(phpAds_Admin)) {
		$query = "SELECT campaignid,campaignname".
			" FROM ".$conf['table']['prefix'].$conf['table']['campaigns'].
			" WHERE campaignid!=".$campaignid;
	} elseif (phpAds_isUser(phpAds_Agency)) {
		$query = "SELECT m.campaignid AS campaignid".
			",m.campaignname AS campaignname".
			" FROM ".$conf['table']['prefix'].$conf['table']['campaigns']." AS m".
			",".$conf['table']['prefix'].$conf['table']['clients']." AS c".
			" WHERE m.clientid=c.clientid".
			" AND m.campaignid!=".$campaignid.
			" AND c.agencyid=".phpAds_getAgencyID();
	}
	$res = phpAds_dbQuery($query)
		or phpAds_sqlDie();
	
	while ($row = phpAds_dbFetchArray($res)) {
		$extra .= "<option value='".$row['campaignid']."'>".phpAds_buildName($row['campaignid'], $row['campaignname'])."</option>";
	}
	
	$extra .= "</select>&nbsp;<input type='image' name='moveto' src='images/".$phpAds_TextDirection."/go_blue.gif'><br />";
	$extra .= "<img src='images/break.gif' height='1' width='160' vspace='4'><br />";
	$extra .= "<img src='images/icon-duplicate-acl.gif' align='absmiddle'>&nbsp;$strApplyLimitationsTo<br />";
	$extra .= "<img src='images/spacer.gif' height='1' width='160' vspace='2'><br />";
	$extra .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
	$extra .= "<select name='applyto' style='width: 110;'>";
	
	$res = phpAds_dbQuery("SELECT * FROM ".$conf['table']['prefix'].$conf['table']['banners']." WHERE bannerid != '".$bannerid."' AND campaignid = '".$campaignid."'") or phpAds_sqlDie();
	while ($row = phpAds_dbFetchArray($res))
		$extra .= "<option value='".$row['bannerid']."'>".phpAds_buildBannerName ($row['bannerid'], $row['description'], $row['alt'])."</option>";
	
	$extra .= "</select>&nbsp;<input type='image' name='applyto' src='images/".$phpAds_TextDirection."/go_blue.gif'><br />";
	$extra .= "<img src='images/break.gif' height='1' width='160' vspace='4'><br />";
	$extra .= "<img src='images/icon-recycle.gif' align='absmiddle'>&nbsp;<a href='banner-delete.php?clientid=".$clientid."&campaignid=".$campaignid."&bannerid=".$bannerid."&returnurl=campaign-banners.php'".phpAds_DelConfirm($strConfirmDeleteBanner).">$strDelete</a><br />";
	$extra .= "</form>";
	
	phpAds_PageHeader("4.1.3.3.3", $extra);
	echo "<img src='images/icon-advertiser.gif' align='absmiddle'>&nbsp;".phpAds_getParentClientName($campaignid);
	echo "&nbsp;<img src='images/".$phpAds_TextDirection."/caret-rs.gif'>&nbsp;";
	echo "<img src='images/icon-campaign.gif' align='absmiddle'>&nbsp;".phpAds_getCampaignName($campaignid);
	echo "&nbsp;<img src='images/".$phpAds_TextDirection."/caret-rs.gif'>&nbsp;";
	echo "<img src='images/icon-banner-stored.gif' align='absmiddle'>&nbsp;<b>".phpAds_getBannerName($bannerid)."</b><br /><br />";
	echo phpAds_buildBannerCode($bannerid)."<br /><br /><br /><br />";
	
	phpAds_ShowSections(array("4.1.3.3.2", "4.1.3.3.4","4.1.3.3.3", "4.1.3.3.6"));

$aclPageContaxt = ob_get_clean();

$aclFormTargetUrl = 'banner-acl.php';
$aclRemoveUrl = "banner-acl.php?clientid=".$clientid."&campaignid=".$campaignid."&bannerid=".$bannerid."&action[clear]=true";

$showChannels = true;

// Require banner.acl.inc.php file
require_once 'acl.inc.php';

?>